#include "Sender.h"

#include <QtGui/QApplication>
#include <QtGui/QHBoxLayout>
#include <QtCore/QString>

#include <osc/OscOutboundPacketStream.h>

Sender::Sender() : QWidget()
{
    _sock = new QUdpSocket();
    QHBoxLayout* l = new QHBoxLayout(this);
    this->setLayout(l);
    _line = new QLineEdit(this);
    _line->show();
    l->addWidget(_line);

    _btn = new QPushButton(this);
    _btn->setText("Send");
    _btn->show();
    l->addWidget(_btn);

    connect(_btn, SIGNAL(pressed()), this, SLOT(sendMessage()));
}

Sender::~Sender()
{

}

void
Sender::sendMessage()
{
    QString target(_line->text());
    char buffer[2048];
    osc::OutboundPacketStream packets(buffer, 2048);
    packets.Clear();
    packets << osc::BeginMessage( target.toLocal8Bit().constData())
        << osc::EndMessage;
    _sock->writeDatagram(packets.Data(), packets.Size(), QHostAddress::LocalHost, Sender::port);
    

}



int main(int argc, char** argv)
{
    QApplication app(argc, argv);
    Sender* sender = new Sender();
    sender->show();
    app.exec();
}



//EOF Sender.cpp


